<template>
  <b-button-group class="wrapper-input-button">
    <b-button
      v-if="fixedValueMode"
      v-b-tooltip.hover.top="t('lockInfo')"
      :disabled="fixedValueDisabled[entryIndex]"
      class="innerButton"
      variant="outline-secondary"
      @click.prevent="changeLockable"
    >
      <i-mdi-lock v-if="locked" />
      <i-mdi-lock-open v-else />
    </b-button>
    <b-button
      v-if="fixedValueMode"
      v-b-tooltip.hover.top="t('invisibilityInfo')"
      :disabled="disabledMode || !fieldCanBeInvisible"
      class="innerButton"
      variant="outline-secondary"
      @click.prevent="changeVisibility"
    >
      <i-mdi-visibility-off v-if="invisible" />
      <i-mdi-visibility v-else />
    </b-button>
    <b-button
      v-if="entryIndex === 0"
      v-b-tooltip.hover.top="t('plusInfo')"
      :disabled="disabledMode || insertNewFieldButtonDisabled"
      class="innerButton lastButton"
      variant="outline-secondary"
      @click.prevent="insertNewFields(1)"
    >
      <i-mdi-plus />
    </b-button>
    <b-button
      v-if="entryIndex !== 0"
      :disabled="disabledMode || removeFieldButtonDisabled"
      class="innerButton lastButton"
      variant="outline-secondary"
      @click.prevent="removeField(entryIndex)"
    >
      <i-mdi-minus />
    </b-button>
  </b-button-group>
</template>

<script lang="ts">
import i18n from '@/plugins/i18n';

export default defineComponent({
  name: 'WrapperButtonGroup',
  props: {
    disabledMode: {
      default: false,
      type: Boolean,
    },
    entryIndex: {
      required: true,
      type: Number,
    },
    fieldCanBeInvisible: {
      default: false,
      type: Boolean,
    },
    fixedValueDisabled: {
      required: true,
      type: Array as PropType<Array<boolean>>,
    },
    fixedValueMode: {
      default: false,
      type: Boolean,
    },
    insertNewFieldButtonDisabled: {
      default: false,
      type: Boolean,
    },
    invisible: {
      default: false,
      type: Boolean,
    },
    locked: {
      default: false,
      type: Boolean,
    },
    removeFieldButtonDisabled: {
      default: false,
      type: Boolean,
    },
  },
  setup() {
    return { locale: i18n.global.locale, t: i18n.global.t };
  },
  methods: {
    changeLockable() {
      this.$emit('changeLockable');
    },
    changeVisibility() {
      this.$emit('changeVisibility');
    },
    insertNewFields(count: number) {
      this.$emit('insertNewFields', count);
    },
    removeField(index: number) {
      this.$emit('removeField', index);
    },
  },
});
</script>

<style scoped>
.wrapper-input-button :deep(.unplugin-icon-form-generator) {
  width: 1.2em;
  height: 1.2em;
}
.wrapper-input-button :deep(.overflow-auto) {
  width: 12rem;
}
.lastButton {
  border-bottom-right-radius: inherit !important;
  border-top-right-radius: inherit !important;
}
</style>
